<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "scan_task".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "ScanTask".
 *
 * Columns in table "scan_task" available as properties of the model,
 * followed by relations of table "scan_task" available as properties of the model.
 *
 * @property string $id
 * @property string $type_id
 * @property string $url
 *
 * @property ScanErrorTask[] $scanErrorTasks
 * @property Type $type
 */
abstract class BaseScanTask extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'scan_task';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'ScanTask|ScanTasks', $n);
    }

    public static function representingColumn()
    {
        return 'url';
    }

    public function rules()
    {
        return array(
            array('type_id, url', 'required'),
            array('type_id', 'length', 'max'=>10),
            array('id, type_id, url', 'safe', 'on'=>'search'),
        );
    }

    public function relations()
    {
        return array(
            'scanErrorTasks' => array(self::HAS_MANY, 'ScanErrorTask', 'scan_task_id'),
            'type' => array(self::BELONGS_TO, 'Type', 'type_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'type_id' => null,
            'url' => Yii::t('app', 'Url'),
            'scanErrorTasks' => null,
            'type' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id, true);
        $criteria->compare('type_id', $this->type_id);
        $criteria->compare('url', $this->url, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria, 'pagination' => array('pageSize' => 100)
        ));
    }

}
